from ckanext.odsh.uri_store import add_uri, get_id_from_uri, _set_uri_to_id, _get_uri_to_id
import unittest

class Test_uri_store(unittest.TestCase):
    def test_add_uri_adds_values_to_dict(self):
        _set_uri_to_id({'http://some_uri': 'some_id'})
        dataset_dict = {
            'id': 'some_new_id',
            'extras': [
                {'key': 'uri', 'value': 'http://some_new_uri'},
            ]
        }
        add_uri(dataset_dict)
        assert _get_uri_to_id().get('http://some_uri') ==  'some_id'
        assert _get_uri_to_id().get('http://some_new_uri') =='some_new_id'
    
    def test_get_id_returns_id(self):
        _set_uri_to_id({'http://some_uri': 'some_id'})
        uri = 'http://some_uri'
        id = get_id_from_uri(uri)
        id_expected = 'some_id'
        assert id ==  id_expected
    
    def test_get_id_from_uri_returns_None_if_dict_empty(self):
        _set_uri_to_id({})
        id = get_id_from_uri('some_uri')
        assert id ==  None
    
    def test_get_id_from_uri_returns_None_if_id_unknown(self):
        _set_uri_to_id({'uri_to_id': {'http://some_uri': 'some_id'}})
        id = get_id_from_uri('some_unknown_id')
        assert id ==  None
