import ckan.plugins.toolkit as toolkit
import ckan.authz as authz
from flask import Blueprint
import ckan.views.dataset as dataset
from ckan.common import g
import logging

log = logging.getLogger(__name__)

blueprint = Blueprint('odsh_harvest', __name__)

def new():
    log.debug("views.harvest::new")
    is_sysadmin = authz.is_sysadmin(g.user)

    if not is_sysadmin:
        toolkit.abort(403)
    return dataset.CreateView.as_view(str(u'new'))(u'harvest')

def read(id):
    log.debug("views.harvest::read")
    is_sysadmin = authz.is_sysadmin(g.user)

    if not is_sysadmin:
        toolkit.abort(403)
    return dataset.read(u'harvest', id)

def search():
    log.debug("views.harvest::search")
    is_sysadmin = authz.is_sysadmin(g.user)

    if not is_sysadmin:
        toolkit.abort(403)
    return dataset.search(u'harvest')

def about(id):
    log.debug("views.harvest::about")
    is_sysadmin = authz.is_sysadmin(g.user)

    if not is_sysadmin:
        toolkit.abort(403)
    return dataset.about(id)
